/* 
 * $RCSfile: fddi_host.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: fddi_host.h,v $
 * Revision 1.4  1994/02/04 20:55:11  menze
 *   [ 1994/01/29          menze ]
 *   Using xk_u_intN types instead of u_shorts
 *
 *   [ 1993/12/23          menze ]
 *   Added fddiHostStr and str2fddiHost prototypes
 *
 * Revision 1.3  1993/12/16  21:41:19  menze
 * Regressed to using unsigned shorts instead of the HalfWord types.
 *
 * Revision 1.2  1993/12/15  23:02:37  menze
 * Includes platform.h instead of all.h
 *
 * Revision 1.1  1993/11/13  00:59:37  menze
 * Original version from UMass
 *
 *
 * 1.1
 * 1993/06/19 13:48:14
 *
 * Based on xkernel/include/prot/eth_host.h (DJY)
 */


#ifndef fddi_host_h
#define fddi_host_h
#include "platform.h"

/* 
 * Address types - 
 *   we assume 48 bit rather than 16 bit FDDI addresses.
 */
typedef struct {
    xk_u_int16	high;
    xk_u_int16	mid;
    xk_u_int16	low;
} FDDIhost, fddiAddressType;


#ifdef __STDC__

char *		fddiHostStr( FDDIhost * );
xkern_return_t	str2fddiHost( FDDIhost *, char * );

#else

char *		fddiHostStr();
xkern_return_t	str2fddiHost();

#endif /* __STDC__ */

#endif /* fddi_host_h */

