/*
 * $RCSfile: sim_fddi_i.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: sim_fddi_i.h,v $
 * Revision 1.1.1.1  1994/03/14 21:10:28  umass
 * Increased send and receive buffer sizes
 *
 * Revision 1.1  1993/11/13  00:45:33  menze
 * Original version from UMass
 *
 * Based on xkernel/irix/drivers/eth/sim_ether_i.h (DJY)
 */

#define SIMFDDI_MAX_INSTANCES	5
#define MAX_FDDI_WARM_POOL      10
/*
 * MAX_FDDI_PACKET_SIZE is from the destination MAC address through the
 * information block, inclusive.
 */
#define MAX_FDDI_PACKET_SIZE    (MAX_FDDI_DATA_SIZE + \
                                 sizeof(FDDIhdr) - sizeof(llc802_2_Type))
/*
 * The MTU is tuned to minimize number of socket reads in ping-pong tests
 * at packet sizes of 8000, 16000, etc.  Note that
 *
 *   450 bytes (for sim driver) = 422 bytes (for real driver) +
 *                                  8 bytes (for IRIX UDP header) +
 *                                 20 bytes (for IRIX IP header)
 *
 * This MTU also makes packets encapsulated in IRIX UDP/IP via simfddi
 * within the FDDI MTU (see RFC 1390).
 */
#define FDDI_MTU_SIZE   (MAX_FDDI_DATA_SIZE-450) /* put packet in 4K page */

#define MAX_ERROR_COUNT 1000

#define RCVBUFSIZE 	((64*1024) - 16)
#define SNDBUFSIZE 	((64*1024) - 16)

typedef struct {
    char	*buf;
    int		len;
    int		sock;
} FDDIMsg;

typedef struct {
    int         mtu;
    int		sock;
    int		port;
    FDDIhost    myHost;
    int		errorCount;
    XObj	arp;
} PState;
