/*     
 * $RCSfile: config.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * $Log: config.h,v $
 * Revision 1.4  1996/09/27 20:38:45  mjk
 * increased thread stack size
 *
 * Revision 1.3  1996/07/10 17:10:22  mjk
 * *** empty log message ***
 *
 * Revision 1.2  1996/05/31  21:47:31  mjk
 * Added EVENT_STACK_SIZE
 *
 * Revision 1.1  1996/02/19  20:16:02  mjk
 * Initial revision
 *
 */
#include <pthread.h>

/* 
 * Configuration-tunable parameters
 */


/* 
 * Default number of shepherd threads started by the simeth driver.
 * These threads are shared by all instances of the driver.  This
 * number can be overridden by a ROM file option of the form:
 *
 *	shepherd threads N
 */
#define SIMETH_SHEPHERD_THREADS	32


/*
 * Duration of one event clock tick, in usec
 */
#define EVENT_INTERVAL 10000


/* 
 * Event PThread stack size 
 */
#define EVENT_STACK_SIZE	PTHREAD_STACK_DEFAULT + 0xf000


/*
 * Internal Only Ethernet address
 */
#define ETH_BOGUS_ADDR = { 0x0000, 0xffff, 0xffff }

