/*     
 * $RCSfile: ptbl_static.c,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: ptbl_static.c,v $
 * Revision 1.6  1993/12/10 20:43:53  menze
 * protocolTables variable (faking config files named in compose) now
 * lives here.
 *
 * Cleaned up initialization interaction with prottbl.c.
 * prottbl_init now lives there.
 *
 */


#include "prottbl.h"

typedef struct {
    char	*name;
    long	relNum;
} MapEntry;


typedef struct {
    char 	*name;
    long	id;
    MapEntry	*map;
} Entry;


char *
protocolTables[2] = {
    "in-kernel", 0	/* dummy name */
};


#include "ptblData.c"


int
protTblParse( s )
    char *s;
{
    static int	done = 0;
    Entry 	*e = entries;
    MapEntry	*mapEnt;

    printf("protTblParse called\n");
    if ( ! done ) {
	done = 1;
	for ( e = entries; e->name; e++ ) {
	    protTblAddProt(e->name, e->id);
	    if ( e->map ) {
		for ( mapEnt = e->map; mapEnt->name; mapEnt ++ ) {
		    protTblAddBinding(e->name, mapEnt->name, mapEnt->relNum);
		}
	    }
	}
    }
    return 0;
}


