/* 
 * dhkx_i.h
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993  Arizona Board of Regents
 *
 * $Revision: 1.4 $
 * $Date: 1994/10/04 20:51:42 $
 */

#ifndef dhkx_i_h
#define dhkx_i_h

#include "process.h"  /* semaphore stuff */
#include "event.h"    /* timeout event */
#include "gmp.h"      /* definition of type MP_INT */


#define TRANSPORT_PROTOCOL 0
#define KEY_MGR_PROTOCOL 1
#define KEY_MGR_SESS_IN 2
#define KEY_MGR_SESS_OUT 1
#define KEY_MGR_SESS_ALL 1  /* Used with ALL_PARTS. */

#define ALL_PARTS     	  4
/* A protocol flag bit.  If ALL_PARTS, both remote and local participants
   are used to select one key manager session.  Otherwise, a separate
   session is opened for each participant, and the keys are made identical.
   Rom option, default is OFF. */

#define DHKX_TIMEOUT 20 /* seconds; rom option */

typedef long 	DHKXhdr;
typedef long 	DHKXtype;
typedef XObj  	PassiveId;
typedef XObj	ActiveId;

/* session states for DHKX protocol  $$change to enum?? */
#define DHKXNEW 1
#define DHKXINIT 2
#define DHKXINITWAIT 3
#define DHKXCOMPUTING 4
#define DHKXRESPONDER 5
#define DHKXREPLYING 6
#define DHKXTRANSPARENT 7

/* magic number for DHKX startup message */
#define DHKXMAGIC 314159265

typedef struct {
    Part	p[2];
    long	state;  /* DHKXNEW, ..., DHKXTRANSPARENT */
    XTime	starttime, endtime, deltatime, endtime2, deltatime2;
    Semaphore	semaphore;
    Event	event;
    MP_INT	x, gx, y, gy, gxy;
} SState;    /* session state */


typedef struct {
    Map		actMap;
    Map 	pasMap;
    int		delay;   /* max time for initiator to wait for reply
			    rom option; default DHKX_TIMEOUT (= 20) seconds */
    int		flags;   /* only ALL_PARTS (= 4) is defined; rom option */
    int		ownhlptype; /* use "self" in xOpen */
} PState;    /* protocol state */


#define	DHKX_ACTIVE_MAP_SZ	32
#define	DHKX_PASSIVE_MAP_SZ	16

#endif

