/*     
 * $RCSfile: total_order_internal.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: total_order_internal.h,v $
 * Revision 1.1  1994/04/18 22:02:08  slm
 * Initial revision
 *
 */

#define MAX_NODES         500
#define MAX_ALIVE_TIMEOUT 20000000

#define MAX(a,b) ((a) > (b) ? (a) : (b))

typedef struct node_entry {
    int type;
    Msg *msg;
    int mcwave;		/* `member of current wave' flag */
} NODE;

typedef struct {
    int mytypes[MAX_TYPE];
    Map map_demux;
} TOTALstate;

typedef struct {
    XObj      psync_sessn;
    int       numcwave,		/* number of nodes in current wave */
	      numlwave;		/* number of nodes in last wave */
    int       *cwavep,*lwavep;	/* pointers to current and last wave arrays */
    int       warr1[MAX_NODES],	/* node arrays for current and last waves */
              warr2[MAX_NODES];
    /* following are used to get a num to index into membership array */
    int       max_num,			/* max num used so far */
	      num_arr[MAX_NODES],	/* array of available num's */
	      nindex;			/* index into num_arr */
    NODE      membership[MAX_NODES];
    int       numpart;
    PSYNCaddr parts[MAX_PART];
    int       alive_wait;
    Event     alive_event;     /* added by dhan to handle the alive msg event */
    Map       map_table;
    Semaphore Ordering;
} Sstate;

typedef struct {
#ifdef XK_FIRST_INT
    int  first;
#else
    char first;
#endif
    int  type;
} Smsg_hdr;

typedef struct {
    int  node;
#ifdef XK_FIRST_INT
    int  first;
#else
    char first;
#endif
    int  type;
    int  opcode;
} Rmsg_hdr;

typedef struct {	/* used to strip header, all but opcode */
    int  node;
#ifdef XK_FIRST_INT
    int  first;
#else
    char first;
#endif
    int  type;
} Strip_hdr;

typedef struct {	/* this header is the entire alive message */
#ifdef XK_FIRST_INT
    int  first;
#else
    char first;
#endif
    int  type;
    int  opcode;
} Alive_hdr;
