/* 
 * ROM file processing
 */


#include "xkernel.h"
#include "tcpf_internal.h"
#include "romopt.h"

static XkReturn   doOpt( Protl, char **, int, int, VOID * );


static ProtlRomOpt	rOpts[] = {
    { "", 3, doOpt }
};


static XkReturn
doOpt( self, str, nFields, line, arg )
    Protl	self;
    char	**str;
    int		nFields, line;
    VOID	*arg;
{
    IPhost	ipaddr;
  
    if ( str2ipHost(&ipaddr, str[1]) == XK_FAILURE ) {
	return XK_FAILURE;
    }
    tcpfRcvrAddr = ipaddr;
    
    tcpfRcvrPort = atoi(str[2]);
    
    xTraceP2(self, TR_MAJOR_EVENTS, "RSR is at IP addr %s, port %d",
	    ipHostStr(&tcpfRcvrAddr), tcpfRcvrPort);

    return XK_SUCCESS;
}


void
tcpfProcessRomFile( self )
    Protl	self;
{
    findProtlRomOpts(self, rOpts, sizeof(rOpts)/sizeof(ProtlRomOpt), 0);
}
