/*
 * $RCSfile: error.c,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1994/10/13 17:43:30 $
 */

#include "usc.h"

int Debug_Level = DEBUGLEVEL;

void crash(char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  fprintf (stderr, "fatal error in line %d: ", LineNum);
  vfprintf (stderr, fmt, args);
  fprintf (stderr, "\n");

  va_end (args);
  if (/*CONSTCOND*/ TRIGGER_COREDUMP)
    abort();
  else
    exit (1);
}

void error (char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  fprintf (stderr, "error in line %d: ", LineNum);
  vfprintf (stderr, fmt, args);
  fprintf (stderr, "\n");
  va_end (args);
}

void warning (char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  fprintf (stderr, "warning: line %d: ", LineNum);
  vfprintf (stderr, fmt, args);
  fprintf (stderr, "\n");
  va_end (args);
}
